#!/bin/bash
LLVM="/media/backuphd/nick/LLVM/build"
DP="/media/backuphd/nick/DP/build"

rm -R bin/IR
mkdir bin/IR
rm runnables/*

cd  bin/

options=("clang" "dp" "dp+SPA" "Quit")
select opt in "${options[@]}"
do
    case $opt in
        "clang")
            for i in $(ls ./*.bc); do
                cp $i IR/$i.ll
                echo "Making Executable: $i"
                $LLVM/bin/clang++ IR/$i.ll -o ../runnables/${i:2:2}.run
            done
            break
            ;;
        "dp")
            for i in $(ls ./*.bc); do
                cp $i IR/$i.ll
                echo "Making Executable: $i"
                $LLVM/bin/clang++ IR/$i.ll -L $DP/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/${i:2:2}.run
            done
            break
            ;;
        "dp+SPA")
            for i in $(ls ./*.bc); do
                cp $i IR/$i.ll
                echo "Omission-Analysis on: $i"
                $LLVM/bin/opt -S -load=$DP/libi/LLVMDPInstrumentationOmission.so -dp-instrumentation-omission -stats IR/$i.ll -o IR/${i}.omissions.ll
                echo "Making Executable: $i"
                $LLVM/bin/clang++ IR/${i}.omissions.ll -L $DP/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/${i:2:2}.run
            done
            break
            ;;
        "Quit")
            exit
            ;;
        *) echo "invalid option $REPLY";;
    esac
done
cd ..
cp dp.conf runnables/ 
