#!/bin/bash
LLVM="/media/backuphd/nick/LLVM/build"
DP="/media/backuphd/nick/DP/build"

rm -R bin/ir
mkdir bin/ir
rm runnables/*

cd  bin/
i=$(basename "${1}")
options=("dp" "dp+1" "dp+2" "Quit")
select opt in "${options[@]}"
do
    case $opt in
        "dp")
            cp $i ir/$i.ll
            echo "Making Executable: $i"
            $LLVM/bin/clang++ ir/$i.ll -L $DP/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/$i
            break
            ;;
        "dp+1")
            cp $i ir/$i.ll
            echo "Omission-Analysis on: $i"
            $LLVM/bin/opt -S -load=$DP/libi/LLVMDPInstrumentationOmission.so -dp-instrumentation-omission -stats ir/$i.ll -fm-path ./FileMapping.txt -o ir/${i}.omissions.ll
            echo "Making Executable: $i"
            $LLVM/bin/clang++ ir/${i}.omissions.ll -L $DP/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/$i
            break
            ;;
        "dp+2")
            cp $i ir/$i.ll
            echo "Omission-Analysis on: $i"
            $LLVM/bin/opt -S -load=$DP/libi/LLVMDPInstrumentationOmission.so -dp-instrumentation-omission -dp-omissions-dump-dot -stats ir/$i.ll -fm-path ./FileMapping.txt -o ir/${i}.omissions.ll
            echo "Making Executable: $i"
            $LLVM/bin/clang++ ir/${i}.omissions.ll -L $DP/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/$i
            break
            ;;
        "Quit")
            exit
            ;;
        *) echo "invalid option $REPLY";;
    esac
done
