# Run Polybench form within BM Folder!
declare -a BMS=(
    "./Linear-Algebra/Kernels/2mm/2mm.c"
    "./Linear-Algebra/Kernels/3mm/3mm.c"
    "./stencils/adi/adi.c"
    "./Linear-Algebra/Kernels/atax/atax.c"
    "./Linear-Algebra/Kernels/bicg/bicg.c"
    "./Linear-Algebra/Kernels/cholesky/cholesky.c"
    "./datamining/correlation/correlation.c"
    "./datamining/covariance/covariance.c"
    "./Linear-Algebra/Kernels/doitgen/doitgen.c"
    "./Linear-Algebra/solvers/durbin/durbin.c"
    "./Linear-Algebra/solvers/dynprog/dynprog.c"
    "./stencils/fdtd-2d/fdtd-2d.c"
    "./stencils/fdtd-apml/fdtd-apml.c"
    "./medley/floyd-warshall/floyd-warshall.c"
    "./Linear-Algebra/Kernels/gemm/gemm.c"
    "./Linear-Algebra/Kernels/gemver/gemver.c"
    "./Linear-Algebra/Kernels/gesummv/gesummv.c"
    "./Linear-Algebra/solvers/gramschmidt/gramschmidt.c"
    "./stencils/jacobi-1d-imper/jacobi-1d-imper.c"
    "./stencils/jacobi-2d-imper/jacobi-2d-imper.c"
    "./Linear-Algebra/solvers/lu/lu.c"
    "./Linear-Algebra/solvers/ludcmp/ludcmp.c"
    "./Linear-Algebra/Kernels/mvt/mvt.c"
    "./medley/reg_detect/reg_detect.c"
    "./stencils/seidel-2d/seidel-2d.c"
    "./Linear-Algebra/Kernels/symm/symm.c"
    "./Linear-Algebra/Kernels/syr2k/syr2k.c"
    "./Linear-Algebra/Kernels/syrk/syrk.c"
    "./Linear-Algebra/Kernels/trisolv/trisolv.c"
    "./Linear-Algebra/Kernels/trmm/trmm.c"
)

rm -R bin/*

FLAGS="-g -O0 -S -emit-llvm -fno-discard-value-names -DPOLYBENCH_TIME"

options=("clang" "dp" "Quit")
select opt in "${options[@]}"
do
    case $opt in
        "clang")
            FLAGS="-g -O0 -S -emit-llvm -fno-discard-value-names -DPOLYBENCH_TIME"
            break
        ;;
        "dp")
            FLAGS="-g -O0 -S -emit-llvm -fno-discard-value-names -DPOLYBENCH_TIME -Xclang -load -Xclang ${DP_BUILD}/libi/LLVMDPInstrumentation.so -mllvm -fm-path -mllvm ./FileMapping.txt"
            break
        ;;
    esac
done

# Compile utilities
${LLVM_BUILD}/bin/clang $FLAGS -c utilities/polybench.c -o bin/polybench.ll
for f in "${BMS[@]}"
do
    DIR=$(dirname "$f")
    file=$(basename "$f")
    echo "Compiling $file"
    ${LLVM_BUILD}/bin/clang $FLAGS -c ${f} -o bin/$file.ll
    ${LLVM_BUILD}/bin/llvm-link bin/$file.ll bin/polybench.ll -o bin/$file.ll
done