#!/bin/bash
rm runnables/*
cd  bin/

options=("clang" "dp" "dp+SPA" "dp+SPA (IS)" "Quit")
select opt in "${options[@]}"
do
    case $opt in
        "clang")
            for i in $(ls ./*.ll); do
                if [ "$i" != "./polybench.ll" ]; then
                    echo "Making Executable: $i"
                    ${LLVM_BUILD}/bin/clang++ $i -lpthread -o ../runnables/$i.run
                fi
            done
            break
            ;;
        "dp")
            for i in $(ls ./*.ll); do
                if [ "$i" != "./polybench.ll" ]; then
                    echo "Making Executable: $i"
                    ${LLVM_BUILD}/bin/clang++ $i -L ${DP_BUILD}/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/$i.run
                fi
            done
            break
            ;;
        "dp+SPA")
            rm -R SPA_IR
            mkdir SPA_IR
            for i in $(ls ./*.ll); do
                if [ "$i" != "./polybench.ll" ]; then
                    echo "Omission-Analysis on: $i"
                    ${LLVM_BUILD}/bin/opt -S -load=${DP_BUILD}/libi/LLVMDPInstrumentationOmission.so -dp-instrumentation-omission -stats $i -fm-path ../FileMapping.txt -o SPA_IR/${i}
                    echo "Making Executable: $i"
                    ${LLVM_BUILD}/bin/clang++ SPA_IR/${i} -L ${DP_BUILD}/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/$i.run
                fi
            done
            break
            ;;
        "dp+SPA (IS)")
            rm -R SPA_IR
            mkdir SPA_IR
            for i in $(ls ./*.ll); do
                if [ "$i" != "./polybench.ll" ]; then
                    echo "Omission-Analysis on: $i"
                    ${LLVM_BUILD}/bin/opt -S -load=${DP_BUILD}/libi/LLVMDPInstrumentationOmission.so -input-sensitive -dp-instrumentation-omission -stats $i -fm-path ../FileMapping.txt -o SPA_IR/${i}
                    echo "Making Executable: $i"
                    ${LLVM_BUILD}/bin/clang++ SPA_IR/${i} -L ${DP_BUILD}/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/$i.run
                fi
            done
            break
            ;;
        "Quit")
            exit
            ;;
        *) echo "invalid option $REPLY";;
    esac
done
cd ..
cp dp.conf runnables/ 
