# Run Polybench form within BM Folder!
N=${1}

rm run-all.log
touch run-all.log

declare -a BMS=(
    "2mm.c.ll.run"
    "3mm.c.ll.run"
    "adi.c.ll.run"
    "atax.c.ll.run"
    "bicg.c.ll.run"
    "cholesky.c.ll.run"
    "correlation.c.ll.run"
    "covariance.c.ll.run"
    "doitgen.c.ll.run"
    "durbin.c.ll.run"
    "dynprog.c.ll.run"
    "fdtd-2d.c.ll.run"
    "fdtd-apml.c.ll.run"
    "floyd-warshall.c.ll.run"
    "gemm.c.ll.run"
    "gemver.c.ll.run"
    "gesummv.c.ll.run"
    "gramschmidt.c.ll.run"
    "jacobi-1d-imper.c.ll.run"
    "jacobi-2d-imper.c.ll.run"
    "lu.c.ll.run"
    "ludcmp.c.ll.run"
    "mvt.c.ll.run"
    "reg_detect.c.ll.run"
    "seidel-2d.c.ll.run"
    "symm.c.ll.run"
    "syr2k.c.ll.run"
    "syrk.c.ll.run"
    "trisolv.c.ll.run"
    "trmm.c.ll.run"
)

for file in "${BMS[@]}"
do
    echo "Running dynamic analysis on $file"
    echo "Running dynamic analysis on $file" >> run-all.log
    L=()
    M=$(echo print $N/2 | python)
    SUM=0
    for i in $(seq 1 $N); do
        O=`runnables/${file}`
        L+=("$O")
        SUM="$(echo print $SUM + $O | python)"
        echo "${i}/${N}: $O"
        echo "${i}/${N}: $O" >> run-all.log
    done
    echo -e "\t\t\tAverage for [$file]: $(echo print $SUM / $N | python)s"
    echo -e "\t\t\tAverage for [$file]: $(echo print $SUM / $N | python)s" >> run-all.log
    S=($(echo "${L[@]}" | tr ' ' '\n' | sort | tr '\n' ' ')) 
    echo -e "\t\t\tMedian for [$file]: ${S[$M]}s"
    echo -e "\t\t\tMedian for [$file]: ${S[$M]}s" >> run-all.log
    echo ${S[$M]}
done
mv runnables/*_dep.txt ${2}
mv run-all.log ${2}