#!/bin/bash
rm -R bin/IR
mkdir bin/IR
rm runnables/*

cd  bin/

options=("clang" "dp" "dp+SPA" "dp+SPA (IS)" "Quit")
select opt in "${options[@]}"
do
    case $opt in
        "clang")
            for i in $(ls ./*.serial); do
                cp $i IR/$i.ll
                echo "Making Executable: $i"
                ${LLVM_BUILD}/bin/clang++ IR/$i.ll -lpthread -o ../runnables/$i
            done
            break
            ;;
        "dp")
            for i in $(ls ./*.dp.serial); do
                cp $i IR/$i.ll
                echo "Making Executable: $i"
                ${LLVM_BUILD}/bin/clang++ IR/$i.ll -L ${DP_BUILD}/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/$i
            done
            break
            ;;
        "dp+SPA")
            for i in $(ls ./*.dp.serial); do
                cp $i IR/$i.ll
                echo "Omission-Analysis on: $i"
                ${LLVM_BUILD}/bin/opt -S -load=${DP_BUILD}/libi/LLVMDPInstrumentationOmission.so -dp-instrumentation-omission -stats IR/$i.ll -fm-path ../FileMapping.txt -o IR/${i}.omissions.ll
                echo "Making Executable: $i"
                ${LLVM_BUILD}/bin/clang++ IR/${i}.omissions.ll -L ${DP_BUILD}/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/$i
            done
            break
            ;;
        "dp+SPA (IS)")
            for i in $(ls ./*.dp.serial); do
                cp $i IR/$i.ll
                echo "Omission-Analysis on: $i"
                ${LLVM_BUILD}/bin/opt -S -load=${DP_BUILD}/libi/LLVMDPInstrumentationOmission.so -dp-instrumentation-omission -input-sensitive -stats IR/$i.ll -fm-path ../FileMapping.txt -o IR/${i}.omissions.ll
                echo "Making Executable: $i"
                ${LLVM_BUILD}/bin/clang++ IR/${i}.omissions.ll -L ${DP_BUILD}/rtlib -lDiscoPoP_RT -lpthread -o ../runnables/$i
            done
            break
            ;;
        "Quit")
            exit
            ;;
        *) echo "invalid option $REPLY";;
    esac
done
cd ..
cp dp.conf runnables/ 
