#!/bin/bash

N=${1}
BASE_DIR=$(dirname $0)
RUN_DIR=run_custom

declare -a BMS=(
	"run-alignment.sh"
	"run-fft.sh"
	"run-fib.sh"
	"run-floorplan.sh"
	"run-health.sh"
	"run-knapsack.sh"
	"run-nqueens.sh"
	"run-sort.sh"
	"run-sparselu.sh"
	"run-strassen.sh"
	"run-uts.sh"
)

for script in "${BMS[@]}"
do
	echo "${BASE_DIR}/run-n-times.sh $RUN_DIR/$script $N" >> run-all.log
	echo "${BASE_DIR}/run-n-times.sh $RUN_DIR/$script $N"
	${BASE_DIR}/run-n-times.sh "$RUN_DIR/$script" "$N"
done
mv ${BASE_DIR}/runnables/*_dep.txt ${2}
mv run-all.log ${2}
